﻿// UAWcfService1: A simple Web service using WCF technology. Provides a GetData method to read a value of an OPC UA 
// variable.
// Use UAWcfClient1 project (under Console folder) to test this Web service.

using OpcLabs.EasyOpc.UA;

// ReSharper disable ArrangeModifiersOrder

namespace UAWcfService1
{
    // NOTE: If you change the class name "Service1" here, you must also update the reference to "Service1" in Web.config and in the associated .svc file.
    public class Service1 : IService1
    {
        // Use a shared client instance to allow for better optimization.
        static private readonly EasyUAClient Client = new EasyUAClient();

        public string GetData()
        {
            UAEndpointDescriptor endpointDescriptor =
                "opc.tcp://opcua.demo-this.com:51210/UA/SampleServer";
            // or "http://opcua.demo-this.com:51211/UA/SampleServer" (not in .NET Standard)
            // or "https://opcua.demo-this.com:51212/UA/SampleServer/"

            object value = Client.ReadValue(endpointDescriptor, "nsu=http://test.org/UA/Data/;i=10845");
            return (value is null) ? "" : value.ToString();
        }
    }
}
